﻿Public Class SavingAccount
  Inherits Account

  Public Sub New(ByVal _name As String, _
                 ByVal _balance As Integer)
    MyBase.New(_name, _balance)
  End Sub

  'リスト5 定期口座
  Public Sub New(ByVal _name As String, _
                 ByVal _balance As Integer, _
                 ByVal _depositTerm As Integer)
    MyBase.New(_name, _balance, _depositTerm)
  End Sub

  'リスト6 入金
  Public Sub Deposit(ByVal _amount As Integer)
    '追加：定期預金額のチェック
    If accountType = "T" And _amount < 10000 Then
      Throw New System.ApplicationException("定期預金は１万円以上からになります！")
    End If
    balance += _amount
  End Sub

  'リスト7 引き出し
  Public Sub Withdraw(ByVal _amount As Integer)
    '追加：定期期間のチェック
    If accountType = "T" And _
        DateDiff(DateInterval.Month, startDate, Today) <= depositTerm * 12 Then
      Throw New System.ApplicationException(depositTerm & _
                                            "年満期なので引き出すことはできません！")
    End If
    If balance < _amount Then
      Throw New System.ApplicationException("残高不足です！")
    End If
    balance -= _amount
  End Sub

  Public Sub SendMoney(ByVal _amount As Integer, _
    ByRef _account As Object)

    Try
      Withdraw(_amount)
    Catch ex As ApplicationException
      Throw
    End Try
    _account.Deposit(_amount)
  End Sub
End Class
