﻿Public Class Account
  Implements IAccount
  Private Shared accountNoCount As Integer = 1000
  Protected accountNo As String
  Protected name As String
  Protected balance As Integer

  Protected accountType As String   '追加 口座タイプ
  Protected depositTerm As Integer  '追加 定期期間
  Protected startDate As Date       '追加 口座開設日

  'リスト3 普通口座を作成するコンストラクタ
  Public Sub New(ByVal _name As String, _
                 ByVal _balance As Integer)
    accountNoCount = accountNoCount + 1
    accountNo = "S" & accountNoCount.ToString
    name = _name
    balance = _balance
    accountType = "S"
    depositTerm = 0
    startDate = Today
  End Sub

  'リスト4 定期口座を作成するコンストラクタ
  Public Sub New(ByVal _name As String, _
                 ByVal _balance As Integer, _
                 ByVal _depositTerm As Integer)
    If _balance < 10000 Then
      Throw New System.ApplicationException("定期預金は１万円以上からになります！")
    Else
      accountNoCount = accountNoCount + 1
      accountNo = "T" & accountNoCount.ToString
      name = _name
      balance = _balance
      accountType = "T"
      depositTerm = _depositTerm
      startDate = Today
    End If
  End Sub

  'リスト10
  Public Function getAccountNo() As String _
  Implements IAccount.getAccountNo
    Return accountNo
  End Function

  Public Function getName() As String _
  Implements IAccount.getName
    Return name
  End Function

  Public Function getBalance() As Integer _
  Implements IAccount.getBalance
    Return balance
  End Function

  Function getDepositTerm() As Integer _
  Implements IAccount.getDepositTerm
    Return depositTerm
  End Function

  Function getStartDate() As Date _
  Implements IAccount.getStartDate
    Return startDate
  End Function

  '入金
  Public Overridable Sub Deposit(ByVal _amount As Integer) _
  Implements IAccount.Deposit
    balance += _amount
  End Sub

  '引き出し
  Public Overridable Sub Withdraw(ByVal _amount As Integer) _
  Implements IAccount.Withdraw
    If balance < _amount Then
      Throw New System.ApplicationException("残高不足です！")
    End If
    balance -= _amount
  End Sub

  '振り込み
  Public Overridable Sub SendMoney(ByVal _amount As Integer, _
                                   ByRef _account As Object) _
  Implements IAccount.SendMoney
    Try
      Withdraw(_amount)       '自分の口座から金額をマイナスする
    Catch ex As ApplicationException
      Throw
    End Try
    _account.Deposit(_amount)   '相手の口座に金額をプラスする
  End Sub
End Class

