﻿Public Class TimeSavingAccount
  Inherits Account

  '定期口座
  Public Sub New(ByVal _name As String, ByVal _balance As Integer, _
                 ByVal _dipositTerm As Integer)
    MyBase.New(_name, _balance, _dipositTerm)
  End Sub

  '入金
  Public Overrides Sub Deposit(ByVal _amount As Integer)
    Dim ret As DialogResult

    If DateDiff(DateInterval.Month, startDate, Today) <= depositTerm * 12 Then
      Throw New System.ApplicationException(depositTerm & _
                                            "年満期後に入金を受け付けます！")
    End If

    If _amount < 10000 Then
      Throw New System.ApplicationException("定期預金は１万円以上からになります！")
    End If

    ret = MessageBox.Show("定期期間は3年でよろしいですか？", _
                          "", MessageBoxButtons.YesNo)

    If ret = DialogResult.Yes Then
      depositTerm = 3
      MyBase.Deposit(_amount)
    Else
      ret = MessageBox.Show("定期期間は5年でよろしいですか？", _
                            "", MessageBoxButtons.YesNo)
      If ret = DialogResult.Yes Then
        depositTerm = 5
        MyBase.Deposit(_amount)
      Else
        Throw New System.ApplicationException("定期期間を決めてから入金してください！")
      End If
    End If
  End Sub

  '引き出し
  Public Overrides Sub Withdraw(ByVal _amount As Integer)
    If DateDiff(DateInterval.Month, startDate, Today) <= depositTerm * 12 Then
      Throw New System.ApplicationException(depositTerm & _
                                            "年満期なので引き出すことはできません！")
    Else
      MyBase.Withdraw(_amount)
    End If
  End Sub

  '振り込み
  Public Overrides Sub SendMoney(ByVal _amount As Integer, ByRef _account As Object)
    Throw New System.ApplicationException("定期預金からの振り込みは受け付けていません！")
  End Sub

End Class
